SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: ''
	classVariableNames: 'GlobalResponseId IsServing ResponseContent Sessions WebSockets'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
applicationPath

	^ '/app'.! !

!S2JWebApp class methodsFor: 'websockets' stamp: 'HK 12/13/2010 13:46'!
closeAllSockets

	self webSockets ifNotNil:
		[ self webSockets do: [ :each |
			each close ].
		self webSockets: OrderedCollection new ].! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/7/2010 18:05'!
defaultMillisecondsToWait

	^ 100.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/2/2010 11:27'!
defaultPort

	^ 8887! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 12:47'!
defaultResponseId

	^ 0.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 13:51'!
defaultSuccessResponse

	^ 'success'! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:05:18.765'!
globalResponseId
	^ GlobalResponseId! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:05:13.316'!
globalResponseId: anObject
	GlobalResponseId := anObject! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
increaseResponseId

	self globalResponseId: self globalResponseId + 1.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
inputPath

	^ '/put'.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:06:06.611'!
isServing
	^ IsServing! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:05:59.586'!
isServing: anObject
	IsServing := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/6/2010 12:44'!
prepareSite

	| site |
	site := SwazooSite newNamed: self siteName.
	site
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/').
	self sessions: Dictionary new.
	^ site! !

!S2JWebApp class methodsFor: 'websockets' stamp: 'HK 12/13/2010 14:35'!
push: aMessage toAllBut: aWebSocket

	self webSockets
		reject: [ :each | each = aWebSocket ]
		thenDo: [ :each |
			Transcript show: 'send: ', aMessage, ' to: ', each.
			each send: aMessage. ]! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/2/2010 11:28'!
removeSite

	SwazooServer singleton removeSite: self site.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/8/2010 10:54'!
replacementDictionary

	^ Dictionary new
		at: '&' put: '%26';
		at: '<' put: '%3C';
		at: '>' put: '%3E';
		yourself.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
resetContent

	self
		globalResponseId: 0;
		responseContent: nil.
	self allInstances do: [ : each  | each localResponseId: 0 ]. ! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:06:29.793'!
responseContent
	^ResponseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:06:34.344'!
responseContent: anObject
	ResponseContent := anObject! !

!S2JWebApp class methodsFor: 'websockets' stamp: 'HK 12/13/2010 13:56'!
sendToAllSockets: aMessage

	self webSockets ifNotNil:
		[ self webSockets do: [ :each |
			each send: aMessage ]].! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:06:51.6'!
sessions
	^ Sessions! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:06:42.105'!
sessions: anObject
	Sessions := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 21:39'!
siteName

	^ 'S2JWebApp'.! !

!S2JWebApp class methodsFor: 'launch' stamp: 'HK 12/7/2010 10:35'!
startWebApp

	self isInstalled ifFalse: [ self prepareSite ].
	self isServing: true.
	self site start.
! !

!S2JWebApp class methodsFor: 'websockets' stamp: 'HK 12/13/2010 14:40'!
terminate

	self webSockets do: [ :each |
		each connection close ].
	self webSockets: OrderedCollection new.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/7/2010 16:49'!
toggleIsServing

	self isServing: self isServing not! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:48'!
updateResponseContentWith: content

	self responseContent: content.
	self increaseResponseId.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'ag 12/9/2010 17:30'!
updateResponseContentWithSqueakCode: content

	| jsCode |
	[ jsCode := S2JPrinter convertStatements: content ]
		on: Exception do: [ :err | jsCode := '"Could not parse squeak-code: ', Character cr asString, content, Character cr asString, 'Error was: ', err asString, '"' ].
	self updateResponseContentWith: jsCode.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/13/2010 10:15'!
webSocketPath

	^ '/ws'.! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:07:10.271'!
webSockets
	^ WebSockets! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'LT 12/21/2010 14:07:14.625'!
webSockets: anObject
	WebSockets := anObject! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:45'!
xmlPath

	^ '/xml'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/6/2010 13:39'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/13/2010 10:08'!
answerCreated

	^ self answerWithStatusCode: 201.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerForbidden

	^ HTTPResponse forbidden.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/13/2010 10:09'!
answerNoContent

	^ self answerWithStatusCode: 204.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/8/2010 10:40'!
answerTo: aRequest 

	| resource response |
		
	resource := self identifierOf: aRequest.
	response := self handleRequest: aRequest for: resource.
	
	(self hasSession: aRequest) ifFalse: [ self startSessionWith: response.].
	
	^ response.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:42'!
answerWebsite

	^ self
		answerContent: self renderWebsite
		withType: 'text/html'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/13/2010 10:09'!
answerWithStatusCode: aNumber

	^ HTTPResponse new statusCode: aNumber.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:45'!
answerXmlDataTo: aRequest

	self increaseLocalResponseIdFor: aRequest.
	^ self
		answerContent: (self wrapUpAsXml: self class responseContent)
		withType: 'text/xml'.! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
clientIsBehindWith: aRequest

	^ self class globalResponseId > (self localResponseIdFor: aRequest).! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 18:04'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	textarea {
		width: 100%;
		background-color: #F9F7ED;
		border: 1px solid #4096EE;
	}
	
	table {
		width: 100%;
	}
	
	th {
		text-align: left;
		width: 45%;
	}

	tr th:first-child {
		width: 10%;	
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}'.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/8/2010 10:43'!
handleInputOf: aRequest

	| content |
	
	content := self postDataOf: aRequest.
	content ifNotNil:
		[self increaseLocalResponseIdFor: aRequest.
		self class updateResponseContentWith: content.
		^ self answerCreated.]! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/13/2010 10:15'!
handleRequest: aRequest for: aResource

	aResource = self class webSocketPath ifTrue:[ ^ self handleWebSocketRequest: aRequest ].
	aResource = self class applicationPath ifTrue: [ ^ self answerWebsite ].
	aResource = self class xmlPath ifTrue: [ ^ self handleXmlRequest: aRequest ].
	aResource = self class inputPath ifTrue: [ ^ self handleInputOf: aRequest ].
	^ self redirectToHome.
	
	! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/13/2010 14:44'!
handleWebSocketRequest: aRequest

	| webSocket response |
	
	webSocket := aRequest webSocket.
	self class webSockets add: webSocket.
	response := webSocket answerTo: aRequest.
	webSocket receiveBlock:
		[ :message |
			Transcript show: 'I received: ', message.
			self class push: message toAllBut: webSocket ].
	^ response.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 14:08'!
handleXmlRequest: aRequest

	^ (self hasNewDataFor: aRequest)
		ifTrue: [ self answerXmlDataTo: aRequest ]
		ifFalse:
			[ self suspendRequestAndExecute:
				[ ^ self handleXmlRequest: aRequest ]].! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
hasNewDataFor: aRequest

	self class responseContent ifNil: [ ^ false ].
	(self hasSession: aRequest) ifFalse: [ ^ true ].
	^ self clientIsBehindWith: aRequest.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 14:23'!
hasSession: aRequest

	^ aRequest cookie notNil and: [ self class sessions includesKey: (aRequest cookie asNumber) ].! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 10:46'!
increaseLocalResponseIdFor: aRequest

	self class sessions at: (aRequest cookie asNumber) put: self class globalResponseId.
	Transcript show: 'Client #', aRequest cookie, ' is now at ', self class globalResponseId asString; cr.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 11:02'!
javascriptCode

	^ '
	var data = null;
	var request = null;
	
	function createXmlRequest() {
		return new XMLHttpRequest();
	}
	
	function poll() {
		request = createXmlRequest();
		request.open("GET", "/xml", true);
		request.onreadystatechange = pollResponseHandler;
		request.send(null);
	}
	
	function pollResponseHandler() {
		if (request.readyState == 4) {
			if (request.status == 200) {
				var xml = request.responseXML.getElementsByTagName("data")[0].firstChild.data;
				log(request.status, decodeURIComponent(xml));
				poll();
			}
			else {
				log(request.status, null);
			}
		}
	}
	
	function push() {
		stop();
		data = document.getElementById("input").value;
		if (data !!= "") {
			request = createXmlRequest();
			request.open("POST", "/put", true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.onreadystatechange = pushResponseHandler;
			request.send(encodeURIComponent(data));
		}
	}
	
	function pushResponseHandler() {	
		if ((request.readyState == 4) && (request.status == 201)) {
			log(201, data);
			poll();
		}
	}

	function stop() {
		if (request !!= null) {
			request.abort();
			request = null;
		}
	}
	
	function alert(text) {
		return text;
	}'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 11:00'!
javascriptCodeForUI

	^ '
	function log(httpStatus, content) {
		if ((httpStatus == 200) || (httpStatus == 201)) {
			var evaluatedContent;
			try {
  				evaluatedContent = eval(content);
				prependRow("green", httpStatus, content, evaluatedContent);
			}
			catch(error) {
				prependRow("red", httpStatus, content, error);
			}
		}
		else if (httpStatus == 204) {
			prependRow("yellow", httpStatus, "No content", "");
		}
		else {
			prependRow("yellow", httpStatus, "Client aborted", "");
		} 
	}
		
	function prependRow(cssClass, httpStatus, logText, evalText) {
		var tbody = document.getElementsByTagName("tbody")[0];
		var firstRow = tbody.getElementsByTagName("tr")[0];
		var newRow = row(cssClass, httpStatus, logText, evalText);
		tbody.insertBefore(newRow, firstRow);
	}
	
	function row(cssClass, httpStatus, logText, evalText) {
		var row = document.createElement("tr");
		row.setAttribute("class", cssClass);
		var httpData = document.createElement("td");
		httpData.innerHTML = httpStatus;
		row.appendChild(httpData);
		var logData = document.createElement("td");
		logData.innerHTML = logText;
		row.appendChild(logData);
		var evalData = document.createElement("td");
		evalData.innerHTML = evalText;
		row.appendChild(evalData);
		return row;
	}
	
	function clearLog() {
		var tbody = document.getElementsByTagName("tbody")[0];
		while (tbody.childNodes.length > 0) {
			tbody.removeChild(tbody.childNodes[0]);
		}
	}
	'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 14:47'!
javascriptCodeWs

	^ '
	var webSocket = null;
	var data = null;

	function checkWsSupport() {
		if ("WebSocket" in window) {
			alert("Your browser supports WebSockets!!");
		}
		else {
			alert("Your browser does not support WebSockets!!");
		}
	}

	function openSocket() {
		webSocket = new WebSocket("ws://localhost:8887/ws");
		
		webSocket.onopen = function(event) {
			alert("Successfully opened WebSocket.");
		}
		
		webSocket.onerror = function(event) {
			alert("Opening WebSocket failed!!");
		}
		
		webSocket.onmessage = function(event) {
			log(200, event.data)
		}
		
		webSocket.onclose = function() {
			alert("The connection has been closed by the server.");
		}
	}
	
	function sendToSocket(message) {
		if (webSocket !!= null) {
			alert("Trying to push.");
			webSocket.send(message);
		}
	}

	function closeSocket() {
		if (webSocket !!= null) {
			alert("Closing socket");
			//webSocket.close();
			//webSocket = null;
			webSocket.send("close");
		}
	}
	
	function push() {
		data = document.getElementById("input").value;
		if (data !!= "") {
			sendToSocket(data);
		}
	}
	
	'.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 13:24'!
localResponseIdFor: aRequest

	^ self class sessions at: (aRequest cookie asNumber).! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:50'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 15:23'!
redirectToHome

	| response |
	response := HTTPResponse redirectLink.
	^ response
		location: self class applicationPath;
		yourself.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 10:03'!
renderBody

	^ '<body><div id="container">',
	self renderContent,
	'</div></body></html>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 10:51'!
renderBodyWs

	^ '<body><div id="container">',
	self renderContentWs,
	'</div></body></html>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/8/2010 10:36'!
renderContent

	^ '<h3>Push your code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="push();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Start polling" onclick="poll();">
	<input type="button" value="Stop polling" onclick="stop();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 10:50'!
renderContentWs

	^ '<h3>Push your code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="push();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Check WsSupport" onclick="checkWsSupport();">
	<input type="button" value="Connect" onclick="openSocket();">
	<input type="button" value="Disconnect" onclick="closeSocket();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 11:06'!
renderHeader

	^ self htmlDocumentType,
	'<html><head><title>',
	self class siteName,
	'</title><script type="text/javascript">',
	self javascriptCodeForUI,
	'</script><script type="text/javascript">',
	self javascriptCodeWs,
	'</script><style type="text/css"><!!--',
	self cssData,
	'--></style></head>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/13/2010 11:01'!
renderWebsite

	^ self renderHeader,
	self renderBodyWs.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 11:04'!
startSessionWith: aResponse

	| randomId |
	[ randomId := 10e10 atRandom ] doWhileTrue:
		[ self class sessions includesKey: randomId ].
	self class sessions at: randomId put: self class defaultResponseId.
	aResponse cookie: randomId asString.
	
	Transcript show: 'Starting session #', randomId asString; cr.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 14:07'!
suspendRequestAndExecute: aBlock
	
	self class isServing ifFalse: [ ^ self answerNoContent ].
	
	self wait.	
	^ aBlock value.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
wait

	(Delay forMilliseconds: self class defaultMillisecondsToWait) wait.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/6/2010 15:12'!
withEncodedUriComponents: contentString

	| temporaryString |
	temporaryString := contentString.
	
	self class replacementDictionary keysAndValuesDo:
		[ :key :value |
			temporaryString := temporaryString copyReplaceAll: key with: value ].

	^ temporaryString.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 18:53'!
wrapUpAsXml: content

	^ self xmlDocumentType, '<data>', (self withEncodedUriComponents: content), '</data>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 00:16'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !

!Number methodsFor: '*SwazooSpike' stamp: 'HK 12/13/2010 12:46'!
asByteArray

	| targetByteArray |
	targetByteArray := ByteArray new: 4.
	Bitmap new encodeBytesOf: self in: targetByteArray at: 1.
	^ targetByteArray.! !
